//+------------------------------------------------------------------+
//|                                                 3D Oscilator.mq4 |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Yellow
#property indicator_color2 Red

extern string TimeFrame   = "current time frame";
extern int    D1RSIPer    =  13;
extern int    D2StochPer  =   8;
extern int    D3tunnelPer =   8;
extern double hot         = 0.4;
extern int    sigsmooth   =   4;
extern bool   Interpolate = true;

//
//
//
//
//

double sig1n[];
double sig2n[];

string IndicatorFileName;
bool   calculating   = false;
bool   returningBars = false;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,sig1n); SetIndexDrawBegin(0,D1RSIPer+D2StochPer+D3tunnelPer+hot+sigsmooth);
   SetIndexBuffer(1,sig2n); SetIndexDrawBegin(1,D1RSIPer+D2StochPer+D3tunnelPer+hot+sigsmooth);

   timeFrame  = stringToTimeFrame(TimeFrame);
         if (TimeFrame=="calculate")  { calculating=true;    return(0); }
         if (TimeFrame=="returnBars") { returningBars=true;  return(0); }

   IndicatorFileName = WindowExpertName();
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-1,Bars-counted_bars);
           if (returningBars) { sig1n[0] = limit;     return(0); }
           if (calculating)   { calculateValues(limit); return(0); }
           if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));


   //
   //
   //
   //
   //
   
 	for(i = limit; i >= 0; i--)
   {
      int      y = iBarShift(NULL,timeFrame,Time[i]);
      datetime t = iTime    (NULL,timeFrame,y);

      //
      //
      //
      //
      //

         sig1n[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",D1RSIPer,D2StochPer,D3tunnelPer,hot,sigsmooth,0,y);
         sig2n[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculate",D1RSIPer,D2StochPer,D3tunnelPer,hot,sigsmooth,1,y);
            if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
            if (!Interpolate) continue;

      //
      //
      //
      //
      //

         for(int n = 1; i+n < Bars && Time[i+n] >= t; n++) continue;
         double factor = 1.0 / n;
         for(int k = 1; k < n; k++)
         {
            sig1n[i+k] = k*factor*sig1n[i+n] + (1.0-k*factor)*sig1n[i];
            sig2n[i+k] = k*factor*sig2n[i+n] + (1.0-k*factor)*sig2n[i];
         }            
   }   
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void calculateValues(int limit)
{
   double cs = D1RSIPer+D2StochPer+D3tunnelPer+hot+sigsmooth;
   double ss = sigsmooth;
      if (ss<2) ss  = 2;
         double sk  = 2/(ss+1.0);
         double sk2 = 2/(ss*0.8+1.0);

   //
   //
   //
   //
   //
   
 	for(int i = limit; i >= 0; i--)
   {
      double rsi    = iRSI(NULL,0,D1RSIPer,PRICE_CLOSE,i);
      double maxrsi = rsi;
      double minrsi = rsi;
      for (int j=i+D2StochPer; j>=i; j--)
      {
            rsi=iRSI(NULL,0,D1RSIPer,PRICE_CLOSE,j);
               if (rsi>maxrsi) maxrsi=rsi;
               if (rsi<minrsi) minrsi=rsi;
      }

      //
      //
      //
      //
      //

      if (maxrsi!=minrsi)      
         double storsi = ((rsi-minrsi)/(maxrsi-minrsi)*200-100);
      else      storsi = 0;         
      double E3D = hot*iCCI(NULL,0,D3tunnelPer,PRICE_TYPICAL,i)+(1-hot)*storsi;
         
      sig1n[i]=sk*E3D+(1-sk)*sig1n[i+1];
      sig2n[i]=sk2*sig1n[i+1]+(1-sk2)*sig2n[i+1];
   }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int char = StringGetChar(tfs,l);
          if((char > 96 && char < 123) || (char > 223 && char < 256))
               tfs = StringSetChar(tfs, l, char - 32);
          else 
              if(char > -33 && char < 0)
                  tfs = StringSetChar(tfs, l, char + 224);
   }
   int tf=0;
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf==0 || tf<Period())      tf=Period();
   return(tf);
}